 
create table RemessaPW
(
    CodigoEmp           char(2)                not null,
    CodigoUnidade       char(8)                not null,
    TipoEmpresa         char(1)                not null,
    CodigoEmpresa       char(5)                not null,
    CodigoDocumento     char(10)               not null,
    Serie               char(3)                not null,
    Numero              char(8)                not null,
    Parcela             char(2)                not null,
    Ocorrencia          char(10)               not null,
    DataOcorrencia      datetime               not null,
    HoraOcorrencia      datetime               not null,
    Emissao             datetime               null    ,
    Vencimento          datetime               null    ,
    BancoCobranca       char(3)                not null,
    AgenciaCobranca     char(10)               not null,
    ContaCobranca       char(12)               not null,
    Valor               dec(12,2)              null    ,
    ValorMulta          dec(12,2)              null    ,
    PercentualMulta     dec(5,2)               null    ,
    PercentualJuros     dec(5,2)               null    ,
    ValorDesconto       dec(12,2)              null    ,
    PercentualDesconto  dec(5,2)               null    ,
    IDBancaria          char(20)               null    ,
    RefBancaria         char(10)               null    ,
    CodigoCarteira      char(2)                null    ,
    TipoOperacao        char(1)                null    ,
    TipoPagamento       char(2)                null    ,
    Poupanca            char(1)                null    ,
    FinalidadeTED       char(5)                null    ,
    DataProcesso        datetime               null    ,
    MatrSel             char(15)               not null,
    MatrEnvio           char(15)               not null
);

Insert into RemessaPW Select CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa,
    CodigoDocumento, Serie, Numero, Parcela, Ocorrencia, DataOcorrencia, HoraOcorrencia,
    Emissao, Vencimento, BancoCobranca, AgenciaCobranca, ContaCobranca, Valor, ValorMulta,
    PercentualMulta, PercentualJuros, ValorDesconto, PercentualDesconto, IDBancaria,
    RefBancaria, CodigoCarteira, TipoOperacao, TipoPagamento, Poupanca,'     ', DataProcesso, MatrSel, 
    MatrEnvio from RemessaP;

alter table RemessaP drop constraint FK_REMESSAP_CTAREM_CONTA;

alter table RemessaP drop constraint FK_REMESSAP_PAPRMP_PARCELAP;

alter table RemessaP drop constraint PK_REMESSAP;

drop table RemessaP; 

create table RemessaP
(
    CodigoEmp           char(2)                not null,
    CodigoUnidade       char(8)                not null,
    TipoEmpresa         char(1)                not null,
    CodigoEmpresa       char(5)                not null,
    CodigoDocumento     char(10)               not null,
    Serie               char(3)                not null,
    Numero              char(8)                not null,
    Parcela             char(2)                not null,
    Ocorrencia          char(10)               not null,
    DataOcorrencia      datetime               not null,
    HoraOcorrencia      datetime               not null,
    Emissao             datetime               null    ,
    Vencimento          datetime               null    ,
    BancoCobranca       char(3)                not null,
    AgenciaCobranca     char(10)               not null,
    ContaCobranca       char(12)               not null,
    Valor               dec(12,2)              null    ,
    ValorMulta          dec(12,2)              null    ,
    PercentualMulta     dec(5,2)               null    ,
    PercentualJuros     dec(5,2)               null    ,
    ValorDesconto       dec(12,2)              null    ,
    PercentualDesconto  dec(5,2)               null    ,
    IDBancaria          char(20)               null    ,
    RefBancaria         char(10)               null    ,
    CodigoCarteira      char(2)                null    ,
    TipoOperacao        char(1)                null    ,
    TipoPagamento       char(2)                null    ,
    Poupanca            char(1)                null    ,
    FinalidadeTED       char(5)                null    ,
    DataProcesso        datetime               null    ,
    MatrSel             char(15)               not null,
    MatrEnvio           char(15)               not null
);

insert into RemessaP select * from RemessaPW; 

 
alter table RemessaP
    add constraint PK_REMESSAP primary key (CodigoEmp, CodigoUnidade,TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela, Ocorrencia, DataOcorrencia, HoraOcorrencia);

alter table RemessaP
    add constraint FK_REMESSAP_PAPRMP_PARCELAP foreign key  (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela)
       references ParcelaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa, CodigoDocumento, Serie, Numero, Parcela);

alter table RemessaP
    add constraint FK_REMESSAP_CTAREM_CONTA foreign key  (CodigoEmp, BancoCobranca, AgenciaCobranca, ContaCobranca)
       references Conta (CodigoEmp, CodigoBanco, CodigoAgencia, Codigo);
 
 
create index RemessaP_FK1 on RemessaP (CodigoEmp, CodigoUnidade, TipoEmpresa, CodigoEmpresa,CodigoDocumento, Serie, Numero);
create index RemessaP_FK2 on RemessaP (CodigoEmp, BancoCobranca, AgenciaCobranca, ContaCobranca, RefBancaria, Ocorrencia); 
create index RemessaP_FK3 on RemessaP (CodigoEmp, Ocorrencia, DataProcesso);
create index RemessaP_FK4 on RemessaP (CodigoEmp, BancoCobranca, AgenciaCobranca, ContaCobranca, Ocorrencia, DataOcorrencia); 
create index RemessaP_FK5 on RemessaP (CodigoEmp, BancoCobranca, AgenciaCobranca, ContaCobranca, Ocorrencia, DataProcesso); 

GRANT ALL ON RemessaP TO BYTEC;

drop table RemessaPW;

